routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::match(['get', 'post'], '/', 'LeadController@index')->middleware('auth');
Route::get('logout', function () {
    Auth::logout();
    return redirect('/');
});

Route::match(['get', 'post'], 'lead/import', 'LeadController@import')->name('lead.import')->middleware('auth');
Route::get('lead/export', 'LeadController@export')->middleware('auth');;
Route::match(['get', 'post'], 'lead/list', 'LeadController@search')->middleware('auth');
Route::match(['get', 'post'], 'account/list', 'AccountController@listAll')->middleware('auth');
Route::get('lead/edit/{id}', 'LeadController@edit')->middleware('auth');
Route::post('lead/assign', 'LeadController@assignLead')->name('lead.assign');
Route::get('import', 'FileImportController@index')->middleware('auth');
Route::get('importSuspectHistory', 'SuspectFileImportController@index')->middleware('auth');
Route::get('province', 'ProvinceController@index')->middleware('auth');
Route::get('lead/edit/{id}', 'LeadController@edit')->middleware('auth');
Route::get('lead/clearFilters', 'LeadController@clearFiltering')->name('lead.clearFilters')->middleware('auth');
Route::resource('user', 'UserController');

Route::match(['get', 'post'], 'user/create', 'UserController@create')->name('user.create')->middleware('auth');
Route::match(['get', 'post'], 'user/changepassword', 'UserController@changePassword')->name('user.changepassword')->middleware('auth');
Route::match(['get', 'post'], 'user/{id?}/resetpassword', 'UserController@resetPassword')->name('user.resetpassword')->middleware('auth');
Route::match(['get', 'post'], 'user/{user_id}/loginAs', 'UserController@loginAs')->name('user.loginAs')->middleware('auth');
Route::match(['get', 'post'], 'notification', 'UserController@getNotifications')->name('user.notification')->middleware('auth');
Route::match(['get', 'post'], 'user/logout', 'UserController@logout')->name('user.logout')->middleware('auth');
Route::resource('lead', 'LeadController');
Route::match(['get', 'post'], 'lead/export', 'LeadController@export')->name('lead.export')->middleware('auth');
Route::resource('account', 'AccountController');
Route::resource('group', 'GroupController');
Route::match(['get', 'post'], 'email-list/{id}/import', 'EmailMarketing\EmailListController@import')->name('email-list.import');
Route::match(['get', 'post'], 'email-campaign/{id}/import', 'EmailMarketing\EmailCampaignController@import')->name('email-campaign.import');
Route::get('email-list/{id}/export', 'EmailMarketing\EmailListController@export')->name('email-list.export');
Route::resource('email-list', 'EmailMarketing\EmailListController');
Route::get('email-campaign/{id}/showPdf', 'EmailMarketing\EmailCampaignController@showPdf')->name('email-campaign.showPdf');
Route::get('email-campaign/{id}/genPdf', 'EmailMarketing\EmailCampaignController@genPdf')->name('email-campaign.genPdf');
Route::get('email-campaign/{id}/regenAllPdf', 'EmailMarketing\EmailCampaignController@regenAllPdf')->name('email-campaign.regenAllPdf');
Route::get('email-campaign/{id}/genAllPdf', 'EmailMarketing\EmailCampaignController@genAllPdf')->name('email-campaign.genAllPdf');
Route::match(['get', 'post'], 'email-template/{id}/edit', 'EmailMarketing\EmailCampaignController@editEmailTemplate')->name('email-template.edit');
Route::resource('email-template', 'EmailMarketing\EmailTemplateController');
Route::get('email-campaign/{id}/showEmail', 'EmailMarketing\EmailCampaignController@showEmail')->name('email-campaign.showEmail');
Route::get('email-campaign/{id}/sendEmail', 'EmailMarketing\EmailCampaignController@sendEmail')->name('email.send');
Route::get('email-campaign/{id}/resend', 'EmailMarketing\EmailCampaignController@resend')->name('email.resend');
Route::get('email-campaign/{id}/sendTestEmail', 'EmailMarketing\EmailCampaignController@sendTestEmail')->name('email.sendTestEmail');
Route::get('email-campaign/{id}/progress', 'EmailMarketing\EmailCampaignController@progress')->name('email.progress');
Route::get('email-campaign/{id}/sendPrivateEmail', 'EmailMarketing\EmailCampaignController@sendPrivateEmail')->name('email.sendPrivate');
Route::resource('email-campaign', 'EmailMarketing\EmailCampaignController');
//Route::post('lead/{data?}', 'LeadController@index');
Route::match(['get', 'post'], 'lead/import', 'LeadController@import')->middleware('auth');

$s = 'social.';
Route::get('/social/redirect/{provider}', ['as' => $s . 'redirect', 'uses' => 'Auth\SocialController@getSocialRedirect']);
Route::get('/social/handle/{provider}', ['as' => $s . 'handle', 'uses' => 'Auth\SocialController@getSocialHandle']);

Route::get('ami', 'AsteriskController@call');
Auth::routes();

Route::get('/home', 'LeadController@index')->middleware('auth');
Route::get('/lead/index', 'LeadController@index')->middleware('auth');
Route::get('/report/campaign', 'ReportController@campaign')->name('report.campaign')->middleware('auth');
Route::get('/test', 'TestController@test')->name('test.test');
Route::get('/parse', 'TestController@parse_grade')->name('test.parse');
Route::get('/authorize', 'TestController@authorizeGoogle')->name('test.authorize');
Route::get('/report/online', 'ReportController@showOnlineStatus')->name('report.online')->middleware('auth');
Route::match(['get', 'post'], '/report/call_summary', 'ReportController@showCallSummaryReport')->name('report.call_summary')->middleware('auth');
Route::match(['get', 'post'], '/report/dmr', 'ReportController@showDmrReport')->name('report.dmr')->middleware('auth');
Route::get('/report/performance', 'ReportController@performance')->name('report.performance')->middleware('auth');
Route::match(['get', 'post'], '/report/lead', 'ReportController@showLeadReport')->name('report.lead')->middleware('auth');
Route::get('/utils/getSchools/{province}', 'UtilsController@getSchools');
Route::get('/utils/getSchools/{province}/{selected}', 'UtilsController@getSchools');
Route::get('/utils/getDistricts/{province}', 'UtilsController@getDistricts');
Route::get('/utils/getDistricts/{province}/{selected}', 'UtilsController@getDistricts');
Route::get('/utils/checkIfPhoneExists/{phone}', 'UtilsController@checkIfPhoneExists');
Route::get('/utils/getOnline/{user_id}', 'UtilsController@getOnline');
Route::get('/utils/getWeight', 'UtilsController@getWeight');
Route::get('/utils/getLeadCost', 'UtilsController@getLeadCost');
Route::get('/utils/checkCost', 'UtilsController@checkCost');
Route::get('/utils/checkList', 'UtilsController@checkList');
Route::get('/utils/getOnlineUsers', 'UtilsController@getOnlineUsers');
Route::get('/utils/fixAssignment', 'UtilsController@fix_assignment');
Route::get('/utils/setOnline/{user_id}', 'UtilsController@setOnline');
Route::get('/call/{phone}/{trunk?}', 'LeadController@call')->name('lead.call')->middleware('auth');
Route::get('/call_test/{phone}/{trunk?}', 'LeadController@call_test')->name('lead.call_test')->middleware('auth');
Route::get('/utils/getOnlineStatus/{user_id}', 'UtilsController@getOnlineStatus');
Route::match(['get', 'post'], '/sms/send', 'UtilsController@sendSms');
Route::resource('cost', 'MarketingCostController');
Route::resource('alarm', 'AlarmController');
Route::resource('cdr', 'CdrController');
Route::resource('class', 'AvailableClassController');
Route::get('class/{id}/toggle', 'AvailableClassController@toggle')->name('class.toggle')->middleware('auth');
Route::resource('source', 'SourceController');
Route::get('lead_status/{id}/toggle', 'LeadStatusController@toggle')->name('lead_status.toggle')->middleware('auth');
Route::resource('lead_status', 'LeadStatusController');
Route::get('call_status/{id}/toggle', 'CallStatusController@toggle')->name('call_status.toggle')->middleware('auth');
Route::resource('call_status', 'CallStatusController');
Route::get('source/{id}/toggle', 'SourceController@toggle')->name('source.toggle')->middleware('auth');
Route::resource('info_source', 'InfoSourceController');
Route::get('info_source/{id}/toggle', 'InfoSourceController@toggle')->name('info_source.toggle')->middleware('auth');
Route::resource('channel', 'ChannelController');
Route::get('channel/{id}/toggle', 'ChannelController@toggle')->name('channel.toggle')->middleware('auth');
Route::resource('campaign', 'CampaignController');
Route::get('campaign/{id}/toggle', 'CampaignController@toggle')->name('campaign.toggle')->middleware('auth');
Route::resource('campus', 'CampusController');
Route::get('campus/{id}/toggle', 'CampusController@toggle')->name('campus.toggle')->middleware('auth');
Route::resource('department', 'DepartmentController');
Route::get('department/{id}/toggle', 'DepartmentController@toggle')->name('department.toggle')->middleware('auth');
Route::resource('school', 'SchoolController');
Route::get('school/{id}/toggle', 'SchoolController@toggle')->name('school.toggle')->middleware('auth');
Route::resource('promotion', 'PromotionController');
Route::get('promotion/{id}/toggle', 'PromotionController@toggle')->name('promotion.toggle')->middleware('auth');
Route::post('alarm/set', 'AlarmController@set')->name('alarm.set')->middleware('auth');
Route::post('alarm/stop', 'AlarmController@stopAlarm')->name('alarm.stop')->middleware('auth');
Route::get('alarm/{user_id}/list', 'AlarmController@getAlarmList')->name('alarm.list')->middleware('auth');
Route::resource('sms', 'SmsController');
Route::resource('alarm', 'AlarmController')->middleware('auth');
Route::post('sms/stop', 'SmsController@stopSmsNotification')->name('sms.stop')->middleware('auth');
Route::get('sms/{user_id}/list', 'SmsController@getUnopenedSmsList')->name('sms.list')->middleware('auth');

app/Group.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Group extends Model
{
    protected $table = 'fptu_group';
}

app/Http/Controllers/GroupController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Group;
use App\User;
use App\Department;
use App\UserGroup;
use Illuminate\Support\Facades\Auth;

class GroupController extends Controller
{
    public function __construct()
    {
        $this->middleware('auth');
    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $group_list = array();
        if (Auth::user()->hasRole('admin'))
            $group_list = Group::all();
        else {
            if (Auth::user()->hasRole('teleteamleader') || Auth::user()->hasRole('promoterteamleader'))
                $group_list = Group::where('team_leader', Auth::id())->get();
            if (Auth::user()->hasRole('manager'))
                $group_list = Group::where('department', Auth::user()->department_id)->get();
        }
        foreach ($group_list as $group) {
            if (!empty($group->team_leader)) {
                $team_leader = User::find($group->team_leader);
                if (!empty($team_leader))
                    $group->team_leader = $team_leader->username;
            }
            if (!empty($group->department))
                $group->department = Department::find($group->department)->name;
            if ($group->type == 1)
                $group->type = 'Telesales';
            if ($group->type == 2)
                $group->type = 'Promoter';
            $member_list = UserGroup::where('group_id', $group->id)->get()->pluck('user_id')->toArray();
            $members = array();
            foreach ($member_list as $member_id) {
                $members[] = User::find($member_id);
            }
            $group->members = $members;
        }
        return view('group.index', ['group_list' => $group_list]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $user_list = User::orderBy('username', 'ASC')->get()->pluck('username', 'id')->toArray();
        $group_type_list = array(1 => 'Telesales', 2 => 'Promoter');
        $department_list = Department::all()->pluck('name', 'id')->toArray();
        return view('group.create', ['department_list' => $department_list, 'user_list' => $user_list, 'group_type_list' => $group_type_list]);

    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $message = '';
        $success = 0;
        $group_count = Group::where(['name' => $request->name])->count();
        $user_list = User::all()->pluck('username', 'id')->toArray();
        $group_type_list = array(1 => 'Telesales', 2 => 'Promoter');
        $department_list = Department::all()->pluck('name', 'id')->toArray();
        if ($group_count > 0) {
            $message = 'Tên nhóm đã tồn tại';
        } else {
            $group = new Group;
            $group->name = $request->name;
            $group->type = $request->type;
            $group->team_leader = $request->team_leader;
            $group->department = $request->department;
            $group->save();
            foreach ($request->member_list as $member_id) {
                UserGroup::firstOrCreate(['user_id' => $member_id, 'group_id' => $group->id]);
            }
            $success = 1;
        }
        return view('group.create', ['success' => $success, 'message' => $message, 'department_list' => $department_list, 'user_list' => $user_list, 'group_type_list' => $group_type_list]);
    }

    /**
     * Display the specified resource.
     *
     * @param  int $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $group = Group::find($id);
        $user_list = User::all()->pluck('username', 'id')->toArray();
        $group_type_list = array(1 => 'Telesales', 2 => 'Promoter');
        $department_list = Department::all()->pluck('name', 'id')->toArray();
        $group->members = UserGroup::where('group_id', $id)->get()->pluck('user_id')->toArray();
        return view('group.edit', ['group' => $group, 'department_list' => $department_list, 'user_list' => $user_list, 'group_type_list' => $group_type_list]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request $request
     * @param  int $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $message = '';
        $success = 0;
        $group_count = Group::where(['name' => $request->name])->count();
        $user_list = User::all()->pluck('username', 'id')->toArray();
        $group_type_list = array(1 => 'Telesales', 2 => 'Promoter');
        $department_list = Department::all()->pluck('name', 'id')->toArray();
        $group = Group::find($id);
        $group->name = $request->name;
        $group->type = $request->type;
        $group->team_leader = $request->team_leader;
        $group->department = $request->department;
        $group->save();
        //var_dump($request->member_list);
        $member_rel_list = UserGroup::where('group_id', $id)->get()->pluck('id')->toArray();
        UserGroup::destroy($member_rel_list);
        if (!empty($request->member_list))
            foreach ($request->member_list as $member_id) {
                UserGroup::create(['user_id' => $member_id, 'group_id' => $id]);
            }
        $group->members = $request->member_list;
        $success = 1;
        return view('group.edit', ['group' => $group, 'success' => $success, 'message' => $message, 'department_list' => $department_list, 'user_list' => $user_list, 'group_type_list' => $group_type_list]);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}

resources/views/group/create.blade.php
@include('includes.header')
<div class="container">
    <div class="row">
        <div class="col-md-8 col-md-offset-2">
            <div class="panel panel-default">
                <div class="panel-heading">Thêm nhóm mới</div>
                <div class="panel-body">
				@if(!empty($message))
					<div class="alert alert-danger" role="alert">{{ $message }}</div>
				@endif
				@if(!empty($success))
					<div class="alert alert-success" role="alert">Tạo nhóm mới thành công!</div>
				@endif
                    <form class="form-horizontal" role="form" method="POST" action="{{ route('group.store') }}">
                        {{ csrf_field() }}

						<div class="form-group{{ $errors->has('email') ? ' has-error' : '' }}">
                            <label for="name" class="col-md-4 control-label">Tên nhóm</label>

                            <div class="col-md-6">
                                <input id="name" type="text" class="form-control" name="name" value="{{ old('name') }}" required autofocus>

                                @if ($errors->has('name'))
                                    <span class="help-block">
                                        <strong>{{ $errors->first('name') }}</strong>
                                    </span>
                                @endif
                            </div>
                        </div>

                        <div class="form-group{{ $errors->has('email') ? ' has-error' : '' }}">
                            <label for="email" class="col-md-4 control-label">Loại nhóm</label>

                            <div class="col-md-6">
                                {{ Form::select('type', $group_type_list, '') }}
                            </div>
                        </div>

                        <div class="form-group{{ $errors->has('password') ? ' has-error' : '' }}">
                            <label for="password" class="col-md-4 control-label">Trưởng nhóm</label>

                            <div class="col-md-6">
							{{ Form::select('team_leader', $user_list, '', ['id' => 'teamleader', 'placeholder' => 'Chưa có']) }}
                            </div>
                        </div>
						
						<div class="form-group">
                            <label for="department" class="col-md-4 control-label">Phòng</label>

                            <div class="col-md-6">
                                {{
								Form::select('department', $department_list, old('department'), ['id' => 'department', 'placeholder' => 'Chọn phòng', 'required' => 'required']) }}
                            </div>
                        </div>
						
						<div class="form-group">
                            <label for="department" class="col-md-4 control-label">Thành viên</label>

                            <div class="col-md-6">
                                {{	Form::select('member_list[]', $user_list, '', ['id' => 'member_list', 'multiple' => true, 'size' => 6]) }}
                            </div>
                        </div>

                        <div class="form-group">
                            <div class="col-md-6 col-md-offset-4">
                                <button type="submit" class="btn btn-primary">
                                    Khởi tạo
                                </button>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>

resources/views/group/edit.blade.php
@include('includes.header')
<div class="container">
    <div class="row">
        <div class="col-md-8 col-md-offset-2">
            <div class="panel panel-default">
                <div class="panel-heading">Chỉnh sửa nhóm</div>
                <div class="panel-body">
				@if(!empty($message))
					<div class="alert alert-danger" role="alert">{{ $message }}</div>
				@endif
				@if(!empty($success))
					<div class="alert alert-success" role="alert">Lưu dữ liệu thành công!</div>
				@endif
                    <form class="form-horizontal" role="form" method="POST" action="{{ route('group.update', $group->id) }}">
                        {{ csrf_field() }}
						{!! method_field('patch') !!}

						<div class="form-group{{ $errors->has('email') ? ' has-error' : '' }}">
                            <label for="name" class="col-md-4 control-label">Tên nhóm</label>

                            <div class="col-md-6">
                                <input id="name" type="text" class="form-control" name="name" value="{{ $group->name }}" required autofocus>

                                @if ($errors->has('name'))
                                    <span class="help-block">
                                        <strong>{{ $errors->first('name') }}</strong>
                                    </span>
                                @endif
                            </div>
                        </div>

                        <div class="form-group{{ $errors->has('email') ? ' has-error' : '' }}">
                            <label for="email" class="col-md-4 control-label">Loại nhóm</label>

                            <div class="col-md-6">
                                {{ Form::select('type', $group_type_list, $group->type) }}
                            </div>
                        </div>

                        <div class="form-group{{ $errors->has('password') ? ' has-error' : '' }}">
                            <label for="password" class="col-md-4 control-label">Trưởng nhóm</label>

                            <div class="col-md-6">
							{{ Form::select('team_leader', $user_list, $group->team_leader, ['id' => 'teamleader', 'placeholder' => 'Chưa có']) }}
                            </div>
                        </div>
						
						<div class="form-group">
                            <label for="department" class="col-md-4 control-label">Phòng</label>

                            <div class="col-md-6">
                                {{
								Form::select('department', $department_list, $group->department, ['id' => 'department', 'placeholder' => 'Chọn phòng', 'required' => 'required']) }}
                            </div>
                        </div>
						
						<div class="form-group">
                            <label for="department" class="col-md-4 control-label">Thành viên</label>

                            <div class="col-md-6">
                                {{	Form::select('member_list[]', $user_list, $group->members, ['id' => 'member_list', 'multiple' => true, 'size' => 6]) }}
                            </div>
                        </div>
						
                        <div class="form-group">
                            <div class="col-md-6 col-md-offset-4">
                                <button type="submit" class="btn btn-primary">
                                    Cập nhật
                                </button>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>

resources/views/group/index.blade.php
@include('includes.header')
<div class="col-md-12">
<h4>Quản lý nhóm</h4>
<a class="btn btn-default" href="{{ route('group.create') }}">Tạo nhóm mới</a><br />
<table class="table table-hover">
	<thead>
		<th></th>
		<th>Tên nhóm</th>
		<th>Trưởng nhóm</th>
		<th>Loại nhóm</th>
		<th>Phòng</th>
		<th>Thành viên</th>
	</thead>
	<tbody>
		@foreach($group_list as $group)
			<tr>
				<td><a href="{{ route('group.edit', $group->id) }}"><i class="fa fa-lg fa-pencil" aria-hidden="true"></i></a></td>
				<td>{{ $group->name }}</td>
				<td>{{ $group->team_leader }}</td>
				<td>{{ $group->type }}</td>
				<td>{{ $group->department }}</td>
				<td>
					@foreach($group->members as $member)
					{{ $member->username }} - {{ $member->full_name }}<br />
					@endforeach
				</td>
			</tr>
		@endforeach
	</tbody>
</table>
</div>
</body>
</html>